use proc_macro::TokenStream;
use quote::quote;
use syn;

#[cfg(test)]
mod tests {
    #[test]
    fn it_works() {
        let result = 2 + 2;
        assert_eq!(result, 4);
    }
}

#[proc_macro_derive(SharedFromSelf, attributes(helper))]
pub fn shared_from_self_derive(input: TokenStream) -> TokenStream {
    let ast = syn::parse(input).unwrap();

    // Build the trait implementation
    impl_shared_from_self_macro(&ast)
}

fn impl_shared_from_self_macro(ast: &syn::DeriveInput) -> TokenStream {
    let name = &ast.ident;
    let (impl_generics, _, _) = ast.generics.split_for_impl();
    let gen = quote! {
        impl #impl_generics SharedFromSelf for #name #impl_generics {
            fn shared_from_self(&self) -> Rc::<RefCell::<Self>> {
                return self._self_wp.upgrade().unwrap();
            }
        }
    };
    gen.into()
}
